﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.WindowsMobile.Status;
using Microsoft.WindowsMobile.PocketOutlook;

namespace CallerInfo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        SystemState _callerChanged;
        SystemState _headsetPresenceChanged;
        private void Form1_Load(object sender, EventArgs e)
        {
            _callerChanged = new SystemState(SystemProperty.PhoneIncomingCallerContact);
            _callerChanged.Changed += new ChangeEventHandler(_callerChanged_Changed);

            _headsetPresenceChanged = new SystemState(SystemProperty.HeadsetPresent);
            _headsetPresenceChanged.Changed += new ChangeEventHandler(_headsetPresenceChanged_Changed);
        }

        void _headsetPresenceChanged_Changed(object sender, ChangeEventArgs args)
        {
            if (SystemState.HeadsetPresent)
                Activate();
        }


        void _callerChanged_Changed(object sender, ChangeEventArgs args)
        {
            Contact caller = SystemState.PhoneIncomingCallerContact;
            if (caller != null)
            {
                txtName.Text = caller.FileAs;
                txtMobile.Text = caller.MobileTelephoneNumber;
                txtEmail.Text = caller.Email1Address;
                txtNotes.Text = caller.Body;
            }
            else
            {
                txtName.Text = "";
                txtMobile.Text = "";
                txtEmail.Text = "";
                txtNotes.Text = "";

            }
        }
    }
}