using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.WindowsMobile.Status;

namespace HOL_MBL01
{
    public partial class ProductForm : Form
    {
        public ProductForm()
        {
            Cursor.Current = Cursors.WaitCursor;
            InitializeComponent();
        }

        const float _designTimeDpiX = 96;
        const float _designTimeDpiY = 96;

        SystemState _oreChanged;

        SizeF _scaleFactor;

        private void ProductForm_Load(object sender, EventArgs e)
        {
            // TODO: Delete this line of code to remove the default AutoFill for 'ordersDataSet.Inventory'.
            this.inventoryTableAdapter.Fill(this.ordersDataSet.Inventory);
            Cursor.Current = Cursors.Default;
            hideColumn();

            _oreChanged = new SystemState(SystemProperty.DisplayRotation);
            _oreChanged.Changed += new ChangeEventHandler(_oreChanged_Changed);

            _scaleFactor = CalculateScaleFactor();
        }

        void _oreChanged_Changed(object sender, ChangeEventArgs args)
        {
            SetLayout();
        }

        SizeF CalculateScaleFactor()
        {
            using (Graphics g = CreateGraphics())
            {
                float displayRatioX = g.DpiX / _designTimeDpiX;
                float displayRatioY = g.DpiY / _designTimeDpiY;

                return new SizeF(displayRatioX, displayRatioY);
            }
        }

        private void SetLayout()
        {
            float screenWidth = Screen.PrimaryScreen.Bounds.Width;
            float screenHeight = Screen.PrimaryScreen.Bounds.Height;
            float widthToHeightRatio = screenWidth / screenHeight;

            if (widthToHeightRatio < 0.8)
                SetPortraitLayout();
            else if (widthToHeightRatio > 1.3)
                SetLandscapeLayout();
            else
                SetCloseRatioLayout();

            Scale(_scaleFactor);
            ResumeLayout();
        }

        private void SetPortraitLayout()
        {
            dataGrid1.Dock = DockStyle.Top;
            dataGrid1.Bounds = new Rectangle(0, 0, 240, 130);

            this.imagePictureBox.Bounds = new Rectangle(58, 136, 125, 125);


        }

        private void SetLandscapeLayout()
        {
            dataGrid1.Dock = DockStyle.Left;
            dataGrid1.Bounds = new Rectangle(0, 0, 160, 220);

            this.imagePictureBox.Bounds = new Rectangle(175, 50, 125, 125);

        }

        private void SetCloseRatioLayout()
        {
            //To Do
        }

        private void inventoryBindingSource_CurrentChanged(object sender, EventArgs e)
        {
            if (_imageBitmap != null)
            {
                _imageBitmap.Dispose();
            }

            DataRowView rowView = (DataRowView)inventoryBindingSource.Current;
            OrdersDataSet.InventoryRow row = (OrdersDataSet.InventoryRow) rowView.Row;
            _imageBitmap = new Bitmap(row.ImageFilename);
            imagePictureBox.Image = _imageBitmap;
        }

        Bitmap _imageBitmap;

        //
        DataGridTableStyle ts = new DataGridTableStyle();

        private void hideColumn()
        {
            // Set the DataGridTableStyle.MappingName property
            // to the table in the data source to map to.
            ts.MappingName = inventoryBindingSource.DataMember;

            // Add it to the datagrid's TableStyles collection
            dataGrid1.TableStyles.Add(ts);

            // Hide the first column (index 0)
            dataGrid1.TableStyles[0].GridColumnStyles[0].Width = 180;
            dataGrid1.TableStyles[0].GridColumnStyles[1].Width = 0;
            dataGrid1.TableStyles[0].GridColumnStyles[2].Width = 0;
            dataGrid1.TableStyles[0].GridColumnStyles[3].Width = 0;
        }


    }
}