﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.Data.SqlServerCe;
using Microsoft.WindowsMobile.Status;

namespace MaxRepEfficiency
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        void DoMergeRepSync()
        {
            SqlCeReplication repl = new SqlCeReplication();
            repl.ConnectionRetryTimeout = _connectionRetryTimeoutSeconds;
            repl.ConnectTimeout = _connectTimeoutMilliseconds;
            repl.SendTimeout = _sendTimeoutMilliseconds;
            repl.ReceiveTimeout = _receiveTimeoutMilliseconds;

            // Set destination, Database, login properties
            // ...

            repl.Synchronize();
        }

        void DoRDAPull()
        { 
            SqlCeRemoteDataAccess rda = new SqlCeRemoteDataAccess();
            rda.ConnectionRetryTimeout = _connectionRetryTimeoutSeconds;
            rda.ConnectTimeout = _connectTimeoutMilliseconds;
            rda.SendTimeout = _sendTimeoutMilliseconds;
            rda.ReceiveTimeout = _receiveTimeoutMilliseconds;

            // Set destination, login properties
            //...

            rda.Pull("localTable", "Select * from serverTable", "provider-sqloledb;database=newdb");
        }

        short _connectionRetryTimeoutSeconds;
        int _connectTimeoutMilliseconds;
        int _sendTimeoutMilliseconds;
        int _receiveTimeoutMilliseconds;

        void SetHighBandwidthTimeoutValues()
        {
            _connectionRetryTimeoutSeconds = 30;
            _connectTimeoutMilliseconds = 3000;
            _sendTimeoutMilliseconds = 1000;
            _receiveTimeoutMilliseconds = 1000;
            Debug.WriteLine("SetHighBandwidthTimeoutValues");
        }

        void SetMediumBandwidthTimeoutValues()
        {
            _connectionRetryTimeoutSeconds = 60;
            _connectTimeoutMilliseconds = 6000;
            _sendTimeoutMilliseconds = 3000;
            _receiveTimeoutMilliseconds = 3000;
            Debug.WriteLine("SetMediumBandwidthTimeoutValues");
        }

        void SetLowBandwidthTimeoutValues()
        {
            _connectionRetryTimeoutSeconds = 60;
            _connectTimeoutMilliseconds = 6000;
            _sendTimeoutMilliseconds = 3000;
            _receiveTimeoutMilliseconds = 3000;
            Debug.WriteLine("SetLowBandwidthTimeoutValues");

        }

        SystemState _connectionsCount;
        private void Form1_Load(object sender, EventArgs e)
        {
            _connectionsCount = new SystemState(SystemProperty.ConnectionsCount);
            _connectionsCount.Changed += new ChangeEventHandler(_connectionsCount_Changed);

            SetTimeoutValues(SystemState.ConnectionsCount);
        }

        void _connectionsCount_Changed(object sender, ChangeEventArgs args)
        {
            int connCount = (int)args.NewValue;
            SetTimeoutValues(connCount);
        }

        void SetTimeoutValues(int connCount)
        {
            if (connCount > 0)
            {
                if (SystemState.ConnectionsDesktopCount > 0)
                    SetHighBandwidthTimeoutValues();
                else if (SystemState.ConnectionsNetworkCount > 0)
                {
                    if (SystemState.WiFiStateConnected)
                        SetMediumBandwidthTimeoutValues();
                    else
                        SetHighBandwidthTimeoutValues();

                }
                else
                    SetLowBandwidthTimeoutValues();
            }

        }
    }
}